Global $sVersion = "1.06"
#cs
****************************************************************************
Titel:		Editor_StartSetup.au3
Autor:		Michael Schrder
Datum:		20.09.2012

Info:		Editor um Rechnernamen aus einer Domnen-OU zu lesen und
			mit einer Programmzeile in die 'Install.ini' einzutragen.

History:
			V1.06
				Parameter '-accepteula' in die PSExec-Befehlszeile hin-
				zugefgt.
			V1.05
				Es wird geprft, ob die Setup-Datei auch wirklich
				vorhanden ist.
			V1.04
				Sind bei einen Push-Installation Rechner nicht er-
				reichbar, so knnen diese anschlieend nach Rckfrage
				in die INI-Datei fr den Rechnerneustart eingetragen
				werden.
				
			V1.03
				Button und Funktion fr "Push-Install" integriert.
				Aktion wird auch in der Log-Datei protokolliert.

			V1.02
				Button und Funktion fr "alle abwhlen" integriert.

			V1.01
				Dateidialog fr Setup-Befehlszeile eingefgt.
				
			V1.00
				Erstrelease.

****************************************************************************
#ce

#include <AD.au3>
#include <TreeviewConstants.au3>
#include <WindowsConstants.au3>
#include <GUIConstants.au3>
#include <GuiTreeView.au3>

Global $sOU = "OU=Computers,DC=Domain,DC=Suffix"
Global $aComputer, $sSetupCmd, $aDefCmds, $sTemp, $iRet, $sLogMsg
Global $aNichtErreichbar [1]
Global $sLogName = @ScriptDir & "\Log.csv"	; Name der Logdatei
Global $iLogSize = 512000					; Maximale Gre der Logdatei in Byte
Global $hGUI = GUICreate("Editor fr Installation per 'StartSetup.exe' V" & $sVersion, 600, 400)
Global $hTree = GUICtrlCreateTreeView(5, 7, 500, 360, BitOr($TVS_HASBUTTONS, $TVS_CHECKBOXES, $TVS_LINESATROOT), $WS_EX_CLIENTEDGE)
Global $hSetupCmd = GUICtrlCreateCombo("Setup-Befehlszeile hier eintragen !", 5, 372, 500, 22)
Global $hSetupCmdExpl = GUICtrlCreateButton("...", 510, 371, 30, 23)
Global $hUncheckAll = GUICtrlCreateButton("alle abwhlen", 510, 345, 85, 23)
Global $bExit = GUICtrlCreateButton("Ende", 510, 6, 85, 30)
Global $bSetupStart = GUICtrlCreateButton("Go !", 510, 41, 85, 30)
Global $bSetupPush = GUICtrlCreateButton("Push-Install !", 510, 76, 85, 30)
GUISetState(@SW_SHOW)

$hTVIL = _GUIImageList_Create(16, 16, 5, 3)
_GUIImageList_AddIcon($hTVIL, "dsuiext.dll", 13)
_GUIImageList_AddIcon($hTVIL, "dsuiext.dll", 1)
_GUIImageList_AddIcon($hTVIL, "dsuiext.dll", 12)
_GUICtrlTreeView_SetNormalImageList($hTree, $hTVIL)

; Default Befehlszeile aus Ini-Datei lesen
If FileExists(@ScriptDir & "\Default_Befehle.ini") Then
	$aDefCmds = IniReadSection(@ScriptDir & "\Default_Befehle.ini", "StartSetup")
	If IsArray($aDefCmds) Then
		$sTemp = ""
		For $i = 1 To $aDefCmds[0][0]
			$sTemp &= $aDefCmds[$i][1] & "|"
		Next
		$sTemp = StringTrimRight($sTemp, 1)
		GUICtrlSetData($hSetupCmd, $sTemp)
		$sTemp = ""
	EndIf
EndIf

_AD_TV_Recursiv($sOU, $hTree)

While 1
	$Msg = GUIGetMsg()
	Switch $Msg
	
		Case $GUI_EVENT_CLOSE, $bExit
			Exit
			
		Case $bSetupStart
			$sSetupCmd = GUICtrlRead($hSetupCmd)
			If StringInStr($sSetupCmd, "Setup-Befehlszeile") Or Not FileExists($sSetupCmd) Or Not (StringInStr($sSetupCmd, ".exe") Or StringInStr($sSetupCmd, ".com") Or StringInStr($sSetupCmd, ".bat") Or StringInStr($sSetupCmd, ".cmd") Or (StringInStr($sSetupCmd, ".vbs") And StringInStr($sSetupCmd, "wscript"))) Then
				Msgbox(48,"Info", "Bitte zuerst eine gltige Befehlszeile eintragen !")
			Else
				$aComputer = _GUICtrlTreeView_GetAllChecked($hTree)
				If Not IsArray($aComputer) Then
					Msgbox(48,"Info", "Es wurde kein Ziel-Rechner gewhlt !")
				Else
					If Msgbox(52, "Achtung !", "     Soll die Installation wirklich auf" & @CRLF & @CRLF & "               " & $aComputer[0] & " Rechnern" & @CRLF & @CRLF & "eingetragen und durchgefhrt werden ?     ") = 6 Then
						For $i = 1 To $aComputer[0]
							$iIniIndex = 0
							Do
								$iIniIndex += 1
								$sRet = IniRead(@ScriptDir & "\Install.ini", $aComputer[$i], $iIniIndex, "NotFound")
							Until $sRet = "NotFound"
							IniWrite(@ScriptDir & "\Install.ini", $aComputer[$i], $iIniIndex, $sSetupCmd)
						Next
						Msgbox(48,"Info", "Programminstallationen wurden in die INI-Datei eingetragen.")
					EndIf
				EndIf
			EndIf
		
		Case $hSetupCmdExpl
			$sCmd = FileOpenDialog("Setup-Programm auswhlen", "", "Ausfhrbar (*.exe;*.com;*.bat;*.cmd)", 1)
			$sCmdNet = DriveMapGet(StringLeft($sCmd, 2))
			If $sCmdNet <> "" Then $sCmd = $sCmdNet & StringMid($sCmd, 3)
			If $sCmd <> "" Then GUICtrlSetData($hSetupCmd, $sCmd, $sCmd)	
			
		Case $GUI_EVENT_PRIMARYDOWN
			$aInfo = GUIGetCursorInfo($hGui)
			If $aInfo[4] = $hTree Then
				$aAdjust = ControlGetPos($hGui, '', $hTree)
				If BitAND(_GUICtrlTreeView_HitTest($hTree, $aInfo[0]-$aAdjust[0]-2, $aInfo[1]-$aAdjust[1]-2), 64) Then
					$hSelect = _GUICtrlTreeView_GetSelection($hTree)
					$checked = _GUICtrlTreeView_GetChecked($hTree, $hSelect)
					$hItem = _GUICtrlTreeView_GetFirstChild($hTree, $hSelect)
					If $hItem Then _SetChildItemsChecked($hTree, $hItem, $checked)
					If $checked Then
						_VerifySiblingItems($hTree, $hSelect)
					Else
						_SetParentItemsUnchecked($hTree, $hSelect)
					EndIf
				EndIf
			EndIf
		
		Case $hUncheckAll
			_GUICtrlTreeView_UncheckAll($hTree)
		
		Case $bSetupPush
			$sSetupCmd = GUICtrlRead($hSetupCmd)
			If StringInStr($sSetupCmd, "Setup-Befehlszeile") Or Not FileExists($sSetupCmd) Or Not (StringInStr($sSetupCmd, ".exe") Or StringInStr($sSetupCmd, ".com") Or StringInStr($sSetupCmd, ".bat") Or StringInStr($sSetupCmd, ".cmd") Or (StringInStr($sSetupCmd, ".vbs") And StringInStr($sSetupCmd, "wscript"))) Then
				Msgbox(48,"Info", "Bitte zuerst eine gltige Befehlszeile eintragen !")
			Else
				$aComputer = _GUICtrlTreeView_GetAllChecked($hTree)
				If Not IsArray($aComputer) Then
					Msgbox(48,"Info", "Es wurde kein Ziel-Rechner gewhlt !")
				Else
					If Not FileExists(@ScriptDir & "\PsExec.exe") Then
						Msgbox(48, "Fehler", "Fr eine Push-Installation ist das Programm 'PsExec.exe' im aktuelle Verzeichnis ntig !")
					Else
						If Msgbox(52, "Achtung !", "     Soll die Installation wirklich SOFORT auf" & @CRLF & @CRLF & "               " & $aComputer[0] & " Rechnern" & @CRLF & @CRLF & "        ausgefhrt werden ?     ") = 6 Then
							SplashTextOn("", "Installation(en) wird/werden durchgefhrt...", 400, 45, -1 , -1, 1)
							$sLogMsg = "Die Installation(en) wurde(n) mit folgendem Ergebis abgeschlossen:" & @CRLF & @CRLF & _
								 "Return-" & @Tab & @Tab & "  Ziel-" & @Tab & @Tab & "Setup-" & @CRLF & _
								 " Code" & @Tab & @Tab & "computer" & @Tab & @Tab & "Befehl" & @CRLF & _
								 "------------------------------------------------------------------------------------------------------------" & @CRLF & @CRLF
							ReDim $aNichtErreichbar [1][2]
							$aNichtErreichbar [0][0] = 0
							For $i = 1 To $aComputer[0]
								If Ping($aComputer[$i], 1000) Then
									$iRet = RunWait(@ScriptDir & '\PsExec.exe -accepteula -i -s \\' & $aComputer[$i] & ' "' & $sSetupCmd & '"', @ScriptDir, @SW_HIDE)
									$sLogMsg &= $iRet & @Tab & @Tab & $aComputer[$i] & @Tab & @Tab & $sSetupCmd & @CRLF
									FileWriteLine($sLogName, $aComputer[$i] & ";" & $sSetupCmd & ";" & @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ";" & $iRet)
									; Wenn Logdatei grer 'Max' dann verkleinern
									If FileGetSize($sLogName) > $iLogSize Then
										$data = FileRead($sLogName)
										$data = StringRight($data, $iLogSize)
										$data = StringMid($data, StringInStr($data, @CRLF) + 2)
										$hLog = FileOpen($sLogName, 2)
											FileWrite($hLog, $data)
										FileClose($hLog)
									EndIf
								Else
									ReDim $aNichtErreichbar [UBound($aNichtErreichbar) + 1][2]
									$aNichtErreichbar [UBound($aNichtErreichbar) - 1][0] = $aComputer[$i]
									$aNichtErreichbar [UBound($aNichtErreichbar) - 1][1] = $sSetupCmd
									$aNichtErreichbar [0][0] = UBound($aNichtErreichbar) - 1
									$sLogMsg &= "---" & @Tab & @Tab & $aComputer[$i] & @Tab & @Tab & "nicht erreichbar" & @CRLF
								EndIf
							Next
							SplashOff()
							Msgbox(0,"Ergebnis",$sLogMsg)
							
							If $aNichtErreichbar[0][0] > 0 Then
								If Msgbox(52, "Achtung !", "    Soll die Installation bei den  " & $aNichtErreichbar[0][0] & "  nicht erreichbaren Rechnern," & @CRLF & @CRLF & " in die INI-Datei fr den nchsten Rechnerstart eingetragen werden ?") = 6 Then
									For $i = 1 To $aNichtErreichbar[0][0]
										$iIniIndex = 0
										Do
											$iIniIndex += 1
											$sRet = IniRead(@ScriptDir & "\Install.ini", $aNichtErreichbar[$i][0], $iIniIndex, "NotFound")
										Until $sRet = "NotFound"
										IniWrite(@ScriptDir & "\Install.ini", $aNichtErreichbar[$i][0], $iIniIndex, $aNichtErreichbar[$i][1])
									Next
									Msgbox(48,"Info", "Programminstallationen wurden in die INI-Datei eingetragen.")
								EndIf
							EndIf
					
						EndIf
					EndIf
				EndIf
			EndIf
			
	EndSwitch
WEnd


;===============================================================================
; Fllt ein TreeView rekursiv mit einer bergebenen OU.
; Zur Zeit ist die Funktion getestet um SUB-OU-, Computer- und Personen-Objekte
; in das TreeView, samt passendem Icon zu bernehmen.
; Autor: micha_he@autoit.de
;===============================================================================
Func _AD_TV_Recursiv($sDN, $hAD_TreeView, $hItemIndex = 0, $bIsADOpen = False)
	; Einmalig das AD ffnen. Sptere Funktionsaufrufe nutzen dann die
	; bestehende Verbindung
	If $bIsADOpen = False Then _AD_Open()
	
	; TV Einlesen vorbereiten
	If $hItemIndex = 0 Then
		SplashTextOn("", "AD wird gelesen...", 200, 45, -1 , -1, 1)
		_GUICtrlTreeView_BeginUpdate($hAD_TreeView)
	EndIf
	
	; Kategorie des Objektes ermitteln ind Bildindex whlen
	Local $iImage, $aObjects, $sCategory
	Local $sName = _AD_GetObjectAttribute($sDN, "name")
	Local $aCat = StringRegExp(_AD_GetObjectAttribute($sDN, "objectCategory"), "CN=(.*?),", 1)
	If IsArray($aCat) Then
		Local $sCategory = $aCat[0]
		Switch $sCategory
			Case "person"
				$iImage = 2
			Case "computer"
				$iImage = 1
			Case Else
				$iImage = 0	
		EndSwitch
	EndIf
	
	; Neues TV-Objekt / -Unterobjekt erzeugen	
	$hNewItemIndex = _GUICtrlTreeView_AddChild($hAD_TreeView, $hItemIndex, $sName, $iImage, $iImage)
	If $sCategory = "Organizational-Unit" Then
		Local $aObjects = _AD_GetObjectsInOU($sDN, "", 1, "distinguishedName")
		If IsArray($aObjects) Then
			For $i = 1 To $aObjects[0]
				_AD_TV_Recursiv($aObjects[$i], $hAD_TreeView, $hNewItemIndex, True)
			Next
		EndIf
	EndIf
	
	; TV Einlesen abschlieen
	If $hItemIndex = 0 Then
		_GUICtrlTreeView_ExpandOneLevel($hAD_TreeView)
		_GUICtrlTreeView_EndUpdate($hAD_TreeView)
		SplashOff()
	EndIf
	
	; AD bei Bedarf/letzte laufende Funktion wieder schlieen
	If $bIsADOpen = False Then _AD_Close()	
	Return
EndFunc   ;==>_AD_TV_Recursiv


;==================================================================================================
; Function Name:   _GUICtrlTreeView_ExpandOneLevel($hTreeView [, $hParentItem=0])
; Description::    Ausklappen nur EINER Ebene eines Items, analog zum Mausklick auf '+'
; Parameter(s):    $hTreeView     Handle des TreeView
;                  $hParentItem   Handle des Auszuklappenden Parent-Items
;                                 Standard 0 ==> Handle des ersten Item im TreeView
; Return:          Erfolg         nichts
;                  Fehler         @error 1  -  TreeView enthlt kein Item
;                                 @error 2  -  Item hat keine Child-Item
; Note:            Die Funktion sollte zwischen _GUICtrlTreeView_BeginUpdate() und _GUICtrlTreeView_EndUpdate()
;                  ausgefhrt werden um ein Flackern zu verhindern
; Author(s):       BugFix (bugfix@autoit.de)   
;==================================================================================================
Func _GUICtrlTreeView_ExpandOneLevel($hTreeView, $hParentItem=0)
    If $hParentItem < 1 Then
        Local $hCurrentItem = _GUICtrlTreeView_GetFirstItem($hTreeView)
    Else
        Local $hCurrentItem = $hParentItem
    EndIf
    If $hCurrentItem = 0 Then Return SetError(1)
    Local $hChild
    Local $countChild = _GUICtrlTreeView_GetChildCount($hTreeView, $hCurrentItem)
    If $countChild = 0 Then Return SetError(2)
    _GUICtrlTreeView_Expand($hTreeView, $hCurrentItem)
    For $i = 1 To $countChild
        If $i = 1 Then 
            $hChild = _GUICtrlTreeView_GetFirstChild($hTreeView, $hCurrentItem)
        Else
            $hChild = _GUICtrlTreeView_GetNextSibling($hTreeView, $hChild)
        EndIf
        If _GUICtrlTreeView_GetChildren($hTreeView, $hChild) Then _GUICtrlTreeView_Expand($hTreeView, $hChild, False)
    Next
EndFunc  ;==>_GUICtrlTreeView_ExpandOneLevel


;===============================================================================
; Ermittelt alle "gecheckten" TreeView-Items und gibt sie als Array zurck.
; Hier eine spezielle Version, die nur "gecheckte" TreeView-Elemente mit einem
; speiziellen Image-Index zurckgibt !
; Autor: micha_he@autoit.de
;===============================================================================
Func _GUICtrlTreeView_GetAllChecked($hTreeView, $iImageIndex = 1)
	Local $hItem = _GUICtrlTreeView_GetFirstItem($hTreeView)
	Local $aResult
	While 1
		If _GUICtrlTreeView_GetChecked($hTreeView, $hItem) And _GUICtrlTreeView_GetImageIndex($hTreeView, $hItem) = $iImageIndex Then
			If Not IsArray($aResult) Then
				Local $aResult[2]
			Else
				ReDim $aResult[UBound($aResult) + 1]
			EndIf
			$aResult[0] = UBound($aResult) - 1
			$aResult[UBound($aResult) - 1] = _GUICtrlTreeView_GetText($hTreeView, $hItem)
		EndIf
		$hItem = _GUICtrlTreeView_GetNext($hTreeView, $hItem)
		If $hItem = 0 Then Exitloop
	Wend
	Return $aResult
EndFunc
;===============================================================================


;===============================================================================
; berprft (rekursiv) ob alle Sibling-Items angehakt sind und setzt, wenn
; zutreffend, den Haken beim Parent-Item
; Autor: oscar@autoit.de
;===============================================================================
Func _VerifySiblingItems($hTreeView, $hItem)
	Local $hTmp, $hSave = $hItem, $iCount = _GUICtrlTreeView_GetSiblingCount($hTreeView, $hItem)
	While True
		$hTmp = _GUICtrlTreeView_GetNextSibling($hTreeView, $hItem)
		If Not $hTmp Then ExitLoop
		$hItem = $hTmp
	WEnd
	Do
		If _GUICtrlTreeView_GetChecked($hTreeView, $hItem) Then $iCount -= 1
		$hItem = _GUICtrlTreeView_GetPrevSibling($hTreeView, $hItem)
	Until Not $hItem
	If Not $iCount Then
		Local $hParent = _GUICtrlTreeView_GetParentHandle($hTreeView, $hSave)
		If $hParent Then
			_GUICtrlTreeView_SetChecked($hTreeView, $hParent)
			_VerifySiblingItems($hTreeView, $hParent)
		EndIf
	EndIf
EndFunc
;===============================================================================


;===============================================================================
; Setzt (rekursiv) den Haken bei allen Child-Items, wenn der Haken bei einem
; Item gesetzt wurde
; Autor: oscar@autoit.de
;===============================================================================
Func _SetChildItemsChecked($hTreeView, $hItem, $checked)
	Do
		Local $hNewItem = _GUICtrlTreeView_GetFirstChild($hTreeView, $hItem)
		If $hNewItem Then _SetChildItemsChecked($hTreeView, $hNewItem, $checked)
		_GUICtrlTreeView_SetChecked($hTreeView, $hItem, $checked)
		$hItem = _GUICtrlTreeView_GetNextChild($hTreeView, $hItem)
	Until Not $hItem
EndFunc
;===============================================================================


;===============================================================================
; Entfernt (rekursiv) den Haken bei allen Parents, wenn der Haken von einem
; Item entfernt wurde
; Autor: oscar@autoit.de
;===============================================================================
Func _SetParentItemsUnchecked($hTreeView, $hItem)
	Local $hParent = _GUICtrlTreeView_GetParentHandle($hTreeView, $hItem)
	If $hParent Then _SetParentItemsUnchecked($hTreeView, $hParent)
	_GUICtrlTreeView_SetChecked($hTreeView, $hItem, False)
EndFunc
;===============================================================================


;===============================================================================
; Setzt alle Elemente eines TreeView auf "Unchecked"
; Autor: micha_he@autoit.de
;===============================================================================
Func _GUICtrlTreeView_UncheckAll($hTreeView)
	_GUICtrlTreeView_BeginUpdate($hTreeView)
	Local $hItem = _GUICtrlTreeView_GetFirstItem($hTreeView)
	Local $aResult
	While 1
		If _GUICtrlTreeView_GetChecked($hTreeView, $hItem) Then _GUICtrlTreeView_SetChecked($hTreeView, $hItem, False)
		$hItem = _GUICtrlTreeView_GetNext($hTreeView, $hItem)
		If $hItem = 0 Then Exitloop
	Wend
	_GUICtrlTreeView_EndUpdate($hTreeView)
	Return $aResult
EndFunc
;===============================================================================