#cs
****************************************************************************
Titel:		StartSetup.au3
Version:	1.03
Datum:		30.11.2011
Autor:		Micha_he@AutoIt.de

Info:		Das kompilierte Script wird als Startscript per Gruppen-
			richtlinie eingetragen und ermglicht mit einer passenden
			INI-Datei, ein automatisiertes Installieren von Anwendungen.

History:	V1.03	30.11.2011
				Logdatei erhlt eine maximale Grenbeschrnkung
				
			V1.02	31.10.2011
				Auf eine Log-Datei "Log.csv" umgestellt. Ein nicht aus-
				fhrbares Kommando, wird mit einem Fehlercode "-1"
				protokolliert.
					
			V1.01	26.10.2011
				Es knnen VBS-Script verarbeitet werden. Diese mssen
				folgendermaen eingetragen werden:
			
				wscript(.exe) [Scriptname.vbs] [/parameter]

			V1.00	29.09.2011
				Erstrelease nach Beta-Test
****************************************************************************
#ce

#include <file.au3>

$sLogName = @ScriptDir & "\Log.csv"	; Name der Logdatei
$iLogSize = 512000					; Maximale Gre der Logdatei in Byte


; Ini-Datei festlegen und passend zum aktuellen Computer die Sektion einlesen
$sIniFile = @ScriptDir & "\Install.ini"
$aInstallCmd = IniReadSection($sIniFile, @ComputerName)

If Not IsArray($aInstallCmd) Then Exit ; Kein Programm zur Installation gefunden !

For $i = 1 To $aInstallCmd[0][0]

	; aktuell auszufhrendes Kommando aus der INI-Datei lschen
	If $i = $aInstallCmd[0][0] Then
		IniDelete($sIniFile, @ComputerName)
	Else
		IniDelete($sIniFile, @ComputerName, $aInstallCmd[$i][0])
	EndIf

	; fhrendes Anfhrungszeichen entfernen und zwischenspeichern
	$sLeft = ""
	If StringLeft($aInstallCmd[$i][1], 1) = '"' Then
		$aInstallCmd[$i][1] = StringTrimLeft($aInstallCmd[$i][1], 1)
		$sLeft = '"'
	EndIf

	; relativen Pfad vervollstndigen
	If StringLeft($aInstallCmd[$i][1], 1) = '.' Then
		$sTemp = _PathFull($aInstallCmd[$i][1])
		If StringLeft($sTemp, 2) = "\\" Then
			$sShare = StringLeft($sTemp, StringInStr($sTemp, "\", 2, 4) - 1)
		EndIf
		If $sTemp <> "" Then
			$aInstallCmd[$i][1] = $sLeft & $sTemp
		Else
			$aInstallCmd[$i][1] = $sLeft & $aInstallCmd[$i][1]
		EndIf
		$sLeft = ""
		$sTemp = ""
	EndIf

	; AutoIt-Makros vervollstndigen
	If StringInStr($aInstallCmd[$i][1], "@") Then
		$aInstallCmd[$i][1] = $sLeft & $aInstallCmd[$i][1]
		$sLeft = ""
		$sTemp = Execute($aInstallCmd[$i][1])
		If $sTemp <> "" Then $aInstallCmd[$i][1] = $sTemp
		$sTemp = ""
	EndIf
	
	; Anfhrungszeichen bei Bedarf wieder voranstellen
	If $sLeft <> "" Then $aInstallCmd[$i][1] = $sLeft & $aInstallCmd[$i][1]

	; Programm ausfhren
	$ret = RunWait($aInstallCmd[$i][1], @TempDir, @SW_SHOW)
	
	; Fehlercode "-1" erzeugen, wenn das Kommando nicht gestartet (z.B. bei
	; Schreibfehlern) werden kann
	If @error <> 0 And $ret = 0 Then $ret = -1
	
	; Aktion in der Log-Datei protokollieren
	FileWriteLine($sLogName, @ComputerName & ";" & $aInstallCmd[$i][1] & ";" & @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ";" & $ret)
	
	; Wenn Logdatei grer 'Max' dann verkleinern
	If FileGetSize($sLogName) > $iLogSize Then
		$data = FileRead($sLogName)
		$data = StringRight($data, $iLogSize)
		$data = StringMid($data, StringInStr($data, @CRLF) + 2)
		$hLog = FileOpen($sLogName, 2)
			FileWrite($hLog, $data)
		FileClose($hLog)
	EndIf
Next
